Index: /trunk/source/Lib/TLibCommon/SEI.h
===================================================================
--- /trunk/source/Lib/TLibCommon/SEI.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/SEI.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -68,18 +68,19 @@
     BUFFERING_PERIOD                     = 0,
     PICTURE_TIMING                       = 1,
-    PAN_SCAN_RECT                        = 2,
-    FILLER_PAYLOAD                       = 3,
-    USER_DATA_REGISTERED_ITU_T_T35       = 4,
-    USER_DATA_UNREGISTERED               = 5,
+    PAN_SCAN_RECT                        = 2,   // TODO: add encoder command line control to create these messages
+    FILLER_PAYLOAD                       = 3,   // TODO: add encoder command line control to create these messages
+    USER_DATA_REGISTERED_ITU_T_T35       = 4,   // TODO: add encoder command line control to create these messages
+    USER_DATA_UNREGISTERED               = 5,   // TODO: add encoder command line control to create these messages
     RECOVERY_POINT                       = 6,
-    SCENE_INFO                           = 9,
-    FULL_FRAME_SNAPSHOT                  = 15,
-    PROGRESSIVE_REFINEMENT_SEGMENT_START = 16,
-    PROGRESSIVE_REFINEMENT_SEGMENT_END   = 17,
-    FILM_GRAIN_CHARACTERISTICS           = 19,
-    POST_FILTER_HINT                     = 22,
+    SCENE_INFO                           = 9,   // TODO: add encoder command line control to create these messages
+    PICTURE_SNAPSHOT                     = 15,  // TODO: add encoder command line control to create these messages
+    PROGRESSIVE_REFINEMENT_SEGMENT_START = 16,  // TODO: add encoder command line control to create these messages
+    PROGRESSIVE_REFINEMENT_SEGMENT_END   = 17,  // TODO: add encoder command line control to create these messages
+    FILM_GRAIN_CHARACTERISTICS           = 19,  // TODO: add encoder command line control to create these messages
+    POST_FILTER_HINT                     = 22,  // TODO: add encoder command line control to create these messages
     TONE_MAPPING_INFO                    = 23,
     FRAME_PACKING                        = 45,
     DISPLAY_ORIENTATION                  = 47,
+    GREEN_METADATA                       = 56,
     SOP_DESCRIPTION                      = 128,
     ACTIVE_PARAMETER_SETS                = 129,
@@ -97,8 +98,11 @@
     KNEE_FUNCTION_INFO                   = 141,
     COLOUR_REMAPPING_INFO                = 142,
-#if U0033_ALTERNATIVE_TRANSFER_CHARACTERISTICS_SEI
-    ALTERNATIVE_TRANSFER_CHARACTERISTICS = 182,
-#endif
-    DEINTERLACED_FIELD_IDENTIFICATION         = 143,
+    DEINTERLACE_FIELD_IDENTIFICATION     = 143, // TODO: add encoder command line control to create these messages
+    CONTENT_LIGHT_LEVEL_INFO             = 144, // TODO: add encoder command line control to create these messages
+    DEPENDENT_RAP_INDICATION             = 145, // TODO: add encoder command line control to create these messages
+    CODED_REGION_COMPLETION              = 146, // TODO: add encoder command line control to create these messages
+    ALTERNATIVE_TRANSFER_CHARACTERISTICS = 147,
+    AMBIENT_VIEWING_ENVIRONMENT          = 148, // TODO: add encoder command line control to create these messages
+#if NH_MV
     LAYERS_NOT_PRESENT                        = 160,
     INTER_LAYER_CONSTRAINED_TILE_SETS         = 161,
@@ -118,4 +122,5 @@
     ,ALTERNATIVE_DEPTH_INFO                    = 181
 #endif
+#endif
 
   };
@@ -165,57 +170,16 @@
 };
 
-static const UInt ISO_IEC_11578_LEN=16;
-
-class SEIuserDataUnregistered : public SEI
-{
-public:
-  PayloadType payloadType() const { return USER_DATA_UNREGISTERED; }
-
-  SEIuserDataUnregistered()
-    : userData(0)
-    {}
-
-  virtual ~SEIuserDataUnregistered()
-  {
-    delete userData;
-  }
-
-  UChar uuid_iso_iec_11578[ISO_IEC_11578_LEN];
-  UInt  userDataLength;
-  UChar *userData;
-};
-
-class SEIDecodedPictureHash : public SEI
-{
-public:
-  PayloadType payloadType() const { return DECODED_PICTURE_HASH; }
-
-  SEIDecodedPictureHash() {}
-  virtual ~SEIDecodedPictureHash() {}
-
-  HashType method;
-
-  TComPictureHash m_pictureHash;
-};
-
-class SEIActiveParameterSets : public SEI
-{
-public:
-  PayloadType payloadType() const { return ACTIVE_PARAMETER_SETS; }
-
-  SEIActiveParameterSets()
-    : activeVPSId            (0)
-    , m_selfContainedCvsFlag (false)
-    , m_noParameterSetUpdateFlag (false)
-    , numSpsIdsMinus1        (0)
-  {}
-  virtual ~SEIActiveParameterSets() {}
-
-  Int activeVPSId;
-  Bool m_selfContainedCvsFlag;
-  Bool m_noParameterSetUpdateFlag;
-  Int numSpsIdsMinus1;
-  std::vector<Int> activeSeqParameterSetId;
-};
+
+typedef std::list<SEI*> SEIMessages;
+
+/// output a selection of SEI messages by payload type. Ownership stays in original message list.
+SEIMessages getSeisByType(SEIMessages &seiList, SEI::PayloadType seiType);
+
+/// remove a selection of SEI messages by payload type from the original list and return them in a new list.
+SEIMessages extractSeisByType(SEIMessages &seiList, SEI::PayloadType seiType);
+
+/// delete list of SEI messages (freeing the referenced objects)
+Void deleteSEIs (SEIMessages &seiList);
+
 
 class SEIBufferingPeriod : public SEI
@@ -279,21 +243,66 @@
 };
 
-class SEIDecodingUnitInfo : public SEI
-{
-public:
-  PayloadType payloadType() const { return DECODING_UNIT_INFO; }
-
-  SEIDecodingUnitInfo()
-    : m_decodingUnitIdx(0)
-    , m_duSptCpbRemovalDelay(0)
-    , m_dpbOutputDuDelayPresentFlag(false)
-    , m_picSptDpbOutputDuDelay(0)
-  {}
-  virtual ~SEIDecodingUnitInfo() {}
-  Int m_decodingUnitIdx;
-  Int m_duSptCpbRemovalDelay;
-  Bool m_dpbOutputDuDelayPresentFlag;
-  Int m_picSptDpbOutputDuDelay;
-};
+class SEIPanScanRect : public SEI
+{
+public:
+  PayloadType payloadType() const { return PAN_SCAN_RECT; }
+
+  SEIPanScanRect() {}
+  virtual ~SEIPanScanRect() {}
+
+  struct PanScanRect
+  {
+    Int leftOffset;
+    Int rightOffset;
+    Int topOffset;
+    Int bottomOffset;
+  };
+
+  UInt m_panScanRectId;
+  Bool m_panScanRectCancelFlag;
+  std::vector<PanScanRect> m_panScanRectRegions;
+  Bool m_panScanRectPersistenceFlag;
+};
+
+
+class SEIFillerPayload : public SEI
+{
+public:
+  PayloadType payloadType() const { return FILLER_PAYLOAD; }
+
+  SEIFillerPayload() {}
+  virtual ~SEIFillerPayload() {}
+
+  UInt m_numFillerFFBytes;
+};
+
+
+class SEIUserDataRegistered : public SEI
+{
+public:
+  PayloadType payloadType() const { return USER_DATA_REGISTERED_ITU_T_T35; }
+
+  SEIUserDataRegistered() {}
+  virtual ~SEIUserDataRegistered() {}
+
+  UShort m_ituCountryCode;
+  std::vector<UChar> m_userData;
+};
+
+
+static const UInt ISO_IEC_11578_LEN=16;
+
+class SEIUserDataUnregistered : public SEI
+{
+public:
+  PayloadType payloadType() const { return USER_DATA_UNREGISTERED; }
+
+  SEIUserDataUnregistered() {}
+  virtual ~SEIUserDataUnregistered() { }
+
+  UChar m_uuid_iso_iec_11578[ISO_IEC_11578_LEN];
+  std::vector<UChar> m_userData;
+};
+
 
 class SEIRecoveryPoint : public SEI
@@ -310,122 +319,109 @@
 };
 
-class SEIFramePacking : public SEI
-{
-public:
-  PayloadType payloadType() const { return FRAME_PACKING; }
-
-  SEIFramePacking() {}
-  virtual ~SEIFramePacking() {}
-
-  Int  m_arrangementId;
-  Bool m_arrangementCancelFlag;
-  Int  m_arrangementType;
-  Bool m_quincunxSamplingFlag;
-  Int  m_contentInterpretationType;
-  Bool m_spatialFlippingFlag;
-  Bool m_frame0FlippedFlag;
-  Bool m_fieldViewsFlag;
-  Bool m_currentFrameIsFrame0Flag;
-  Bool m_frame0SelfContainedFlag;
-  Bool m_frame1SelfContainedFlag;
-  Int  m_frame0GridPositionX;
-  Int  m_frame0GridPositionY;
-  Int  m_frame1GridPositionX;
-  Int  m_frame1GridPositionY;
-  Int  m_arrangementReservedByte;
-  Bool m_arrangementPersistenceFlag;
-  Bool m_upsampledAspectRatio;
-};
-
-class SEISegmentedRectFramePacking : public SEI
-{
-public:
-  PayloadType payloadType() const { return SEGM_RECT_FRAME_PACKING; }
-
-  SEISegmentedRectFramePacking() {}
-  virtual ~SEISegmentedRectFramePacking() {}
-
-  Bool m_arrangementCancelFlag;
-  Int  m_contentInterpretationType;
-  Bool m_arrangementPersistenceFlag;
-};
-
-class SEIDisplayOrientation : public SEI
-{
-public:
-  PayloadType payloadType() const { return DISPLAY_ORIENTATION; }
-
-  SEIDisplayOrientation()
-    : cancelFlag(true)
-    , persistenceFlag(0)
-    , extensionFlag(false)
-    {}
-  virtual ~SEIDisplayOrientation() {}
-
-  Bool cancelFlag;
-  Bool horFlip;
-  Bool verFlip;
-
-  UInt anticlockwiseRotation;
-  Bool persistenceFlag;
-  Bool extensionFlag;
-};
-
-class SEITemporalLevel0Index : public SEI
-{
-public:
-  PayloadType payloadType() const { return TEMPORAL_LEVEL0_INDEX; }
-
-  SEITemporalLevel0Index()
-    : tl0Idx(0)
-    , rapIdx(0)
-    {}
-  virtual ~SEITemporalLevel0Index() {}
-
-  UInt tl0Idx;
-  UInt rapIdx;
-};
-
-class SEIGradualDecodingRefreshInfo : public SEI
-{
-public:
-  PayloadType payloadType() const { return REGION_REFRESH_INFO; }
-
-  SEIGradualDecodingRefreshInfo()
-    : m_gdrForegroundFlag(0)
-  {}
-  virtual ~SEIGradualDecodingRefreshInfo() {}
-
-  Bool m_gdrForegroundFlag;
-};
-
-class SEINoDisplay : public SEI
-{
-public:
-  PayloadType payloadType() const { return NO_DISPLAY; }
-
-  SEINoDisplay()
-    : m_noDisplay(false)
-  {}
-  virtual ~SEINoDisplay() {}
-
-  Bool m_noDisplay;
-};
-
-class SEISOPDescription : public SEI
-{
-public:
-  PayloadType payloadType() const { return SOP_DESCRIPTION; }
-
-  SEISOPDescription() {}
-  virtual ~SEISOPDescription() {}
-
-  UInt m_sopSeqParameterSetId;
-  UInt m_numPicsInSopMinus1;
-
-  UInt m_sopDescVclNaluType[MAX_NUM_PICS_IN_SOP];
-  UInt m_sopDescTemporalId[MAX_NUM_PICS_IN_SOP];
-  UInt m_sopDescStRpsIdx[MAX_NUM_PICS_IN_SOP];
-  Int m_sopDescPocDelta[MAX_NUM_PICS_IN_SOP];
+class SEISceneInfo : public SEI
+{
+public:
+  PayloadType payloadType() const { return SCENE_INFO; }
+
+  SEISceneInfo() {}
+  virtual ~SEISceneInfo() {}
+
+  Bool m_bSceneInfoPresentFlag;
+  Bool m_bPrevSceneIdValidFlag;
+  UInt m_sceneId;
+  UInt m_sceneTransitionType;
+  UInt m_secondSceneId;
+};
+
+class SEIPictureSnapshot : public SEI
+{
+public:
+  PayloadType payloadType() const { return PICTURE_SNAPSHOT; }
+
+  SEIPictureSnapshot() {}
+  virtual ~SEIPictureSnapshot() {}
+
+  UInt m_snapshotId;
+};
+
+
+class SEIProgressiveRefinementSegmentStart : public SEI
+{
+public:
+  PayloadType payloadType() const { return PROGRESSIVE_REFINEMENT_SEGMENT_START; }
+
+  SEIProgressiveRefinementSegmentStart() {}
+  virtual ~SEIProgressiveRefinementSegmentStart() {}
+
+  UInt m_progressiveRefinementId;
+  UInt m_picOrderCntDelta;
+};
+
+
+class SEIProgressiveRefinementSegmentEnd: public SEI
+{
+public:
+  PayloadType payloadType() const { return PROGRESSIVE_REFINEMENT_SEGMENT_END; }
+
+  SEIProgressiveRefinementSegmentEnd() {}
+  virtual ~SEIProgressiveRefinementSegmentEnd() {}
+
+  UInt m_progressiveRefinementId;
+};
+
+
+class SEIFilmGrainCharacteristics: public SEI
+{
+public:
+  PayloadType payloadType() const { return FILM_GRAIN_CHARACTERISTICS; }
+
+  SEIFilmGrainCharacteristics() {}
+  virtual ~SEIFilmGrainCharacteristics() {}
+
+  Bool      m_filmGrainCharacteristicsCancelFlag;
+  UChar     m_filmGrainModelId;
+  Bool      m_separateColourDescriptionPresentFlag;
+  UChar     m_filmGrainBitDepthLumaMinus8;
+  UChar     m_filmGrainBitDepthChromaMinus8;
+  Bool      m_filmGrainFullRangeFlag;
+  UChar     m_filmGrainColourPrimaries;
+  UChar     m_filmGrainTransferCharacteristics;
+  UChar     m_filmGrainMatrixCoeffs;
+  UChar     m_blendingModeId;
+  UChar     m_log2ScaleFactor;
+
+  struct CompModelIntensityValues
+{
+    UChar intensityIntervalLowerBound;
+    UChar intensityIntervalUpperBound;
+    std::vector<Int> compModelValue;
+  };
+
+  struct CompModel
+  {
+    Bool  bPresentFlag;
+    UChar numModelValues; // this must be the same as intensityValues[*].compModelValue.size()
+    std::vector<CompModelIntensityValues> intensityValues;
+  };
+
+  CompModel m_compModel[MAX_NUM_COMPONENT];
+  Bool      m_filmGrainCharacteristicsPersistenceFlag;
+
+};
+
+
+class SEIPostFilterHint: public SEI
+{
+public:
+  PayloadType payloadType() const { return POST_FILTER_HINT; }
+
+  SEIPostFilterHint() {}
+  virtual ~SEIPostFilterHint() {}
+
+  UInt             m_filterHintSizeY;
+  UInt             m_filterHintSizeX;
+  UInt             m_filterHintType;
+  Bool             m_bIsMonochrome;
+  std::vector<Int> m_filterHintValues; // values stored in linear array, [ ( ( component * sizeY + y ) * SizeX ) + x ]
 };
 
@@ -465,4 +461,325 @@
 };
 
+class SEIFramePacking : public SEI
+{
+public:
+  PayloadType payloadType() const { return FRAME_PACKING; }
+
+  SEIFramePacking() {}
+  virtual ~SEIFramePacking() {}
+
+  Int  m_arrangementId;
+  Bool m_arrangementCancelFlag;
+  Int  m_arrangementType;
+  Bool m_quincunxSamplingFlag;
+  Int  m_contentInterpretationType;
+  Bool m_spatialFlippingFlag;
+  Bool m_frame0FlippedFlag;
+  Bool m_fieldViewsFlag;
+  Bool m_currentFrameIsFrame0Flag;
+  Bool m_frame0SelfContainedFlag;
+  Bool m_frame1SelfContainedFlag;
+  Int  m_frame0GridPositionX;
+  Int  m_frame0GridPositionY;
+  Int  m_frame1GridPositionX;
+  Int  m_frame1GridPositionY;
+  Int  m_arrangementReservedByte;
+  Bool m_arrangementPersistenceFlag;
+  Bool m_upsampledAspectRatio;
+};
+
+class SEIDisplayOrientation : public SEI
+{
+public:
+  PayloadType payloadType() const { return DISPLAY_ORIENTATION; }
+
+  SEIDisplayOrientation()
+    : cancelFlag(true)
+    , persistenceFlag(0)
+    , extensionFlag(false)
+    {}
+  virtual ~SEIDisplayOrientation() {}
+
+  Bool cancelFlag;
+  Bool horFlip;
+  Bool verFlip;
+
+  UInt anticlockwiseRotation;
+  Bool persistenceFlag;
+  Bool extensionFlag;
+};
+
+
+class SEIGreenMetadataInfo : public SEI
+  {
+public:
+    PayloadType payloadType() const { return GREEN_METADATA; }
+    SEIGreenMetadataInfo() {}
+
+    virtual ~SEIGreenMetadataInfo() {}
+
+    UInt m_greenMetadataType;
+    UInt m_xsdMetricType;
+    UInt m_xsdMetricValue;
+};
+
+
+class SEISOPDescription : public SEI
+    {
+public:
+  PayloadType payloadType() const { return SOP_DESCRIPTION; }
+
+  SEISOPDescription() {}
+  virtual ~SEISOPDescription() {}
+
+  UInt m_sopSeqParameterSetId;
+  UInt m_numPicsInSopMinus1;
+
+  UInt m_sopDescVclNaluType[MAX_NUM_PICS_IN_SOP];
+  UInt m_sopDescTemporalId[MAX_NUM_PICS_IN_SOP];
+  UInt m_sopDescStRpsIdx[MAX_NUM_PICS_IN_SOP];
+  Int m_sopDescPocDelta[MAX_NUM_PICS_IN_SOP];
+  };
+
+
+class SEIActiveParameterSets : public SEI
+      {
+public:
+  PayloadType payloadType() const { return ACTIVE_PARAMETER_SETS; }
+
+  SEIActiveParameterSets()
+    : activeVPSId            (0)
+    , m_selfContainedCvsFlag (false)
+    , m_noParameterSetUpdateFlag (false)
+    , numSpsIdsMinus1        (0)
+  {}
+  virtual ~SEIActiveParameterSets() {}
+
+  Int activeVPSId;
+  Bool m_selfContainedCvsFlag;
+  Bool m_noParameterSetUpdateFlag;
+  Int numSpsIdsMinus1;
+  std::vector<Int> activeSeqParameterSetId;
+};
+
+class SEIDecodingUnitInfo : public SEI
+{
+public:
+  PayloadType payloadType() const { return DECODING_UNIT_INFO; }
+
+  SEIDecodingUnitInfo()
+    : m_decodingUnitIdx(0)
+    , m_duSptCpbRemovalDelay(0)
+    , m_dpbOutputDuDelayPresentFlag(false)
+    , m_picSptDpbOutputDuDelay(0)
+  {}
+  virtual ~SEIDecodingUnitInfo() {}
+  Int m_decodingUnitIdx;
+  Int m_duSptCpbRemovalDelay;
+  Bool m_dpbOutputDuDelayPresentFlag;
+  Int m_picSptDpbOutputDuDelay;
+};
+
+class SEITemporalLevel0Index : public SEI
+{
+public:
+  PayloadType payloadType() const { return TEMPORAL_LEVEL0_INDEX; }
+
+  SEITemporalLevel0Index()
+    : tl0Idx(0)
+    , rapIdx(0)
+    {}
+  virtual ~SEITemporalLevel0Index() {}
+
+  UInt tl0Idx;
+  UInt rapIdx;
+};
+
+
+class SEIDecodedPictureHash : public SEI
+{
+public:
+  PayloadType payloadType() const { return DECODED_PICTURE_HASH; }
+
+  SEIDecodedPictureHash() {}
+  virtual ~SEIDecodedPictureHash() {}
+
+  HashType method;
+
+  TComPictureHash m_pictureHash;
+};
+
+
+class SEIScalableNesting : public SEI
+{
+public:
+  PayloadType payloadType() const { return SCALABLE_NESTING; }
+
+  SEIScalableNesting() {}
+
+  virtual ~SEIScalableNesting()
+  {
+    deleteSEIs(m_nestedSEIs);
+  }
+
+  Bool  m_bitStreamSubsetFlag;
+  Bool  m_nestingOpFlag;
+  Bool  m_defaultOpFlag;                             //value valid if m_nestingOpFlag != 0
+  UInt  m_nestingNumOpsMinus1;                       // -"-
+  UInt  m_nestingMaxTemporalIdPlus1[MAX_TLAYER];     // -"-
+  UInt  m_nestingOpIdx[MAX_NESTING_NUM_OPS];         // -"-
+
+  Bool  m_allLayersFlag;                             //value valid if m_nestingOpFlag == 0
+  UInt  m_nestingNoOpMaxTemporalIdPlus1;             //value valid if m_nestingOpFlag == 0 and m_allLayersFlag == 0
+  UInt  m_nestingNumLayersMinus1;                    //value valid if m_nestingOpFlag == 0 and m_allLayersFlag == 0
+  UChar m_nestingLayerId[MAX_NESTING_NUM_LAYER];     //value valid if m_nestingOpFlag == 0 and m_allLayersFlag == 0. This can e.g. be a static array of 64 UChar values
+
+  SEIMessages m_nestedSEIs;
+};
+
+
+class SEIRegionRefreshInfo : public SEI
+{
+public:
+  PayloadType payloadType() const { return REGION_REFRESH_INFO; }
+
+  SEIRegionRefreshInfo()
+    : m_gdrForegroundFlag(0)
+  {}
+  virtual ~SEIRegionRefreshInfo() {}
+
+  Bool m_gdrForegroundFlag;
+};
+
+
+class SEINoDisplay : public SEI
+{
+public:
+  PayloadType payloadType() const { return NO_DISPLAY; }
+
+  SEINoDisplay()
+    : m_noDisplay(false)
+  {}
+  virtual ~SEINoDisplay() {}
+
+  Bool m_noDisplay;
+};
+
+
+class SEITimeCode : public SEI
+{
+public:
+  PayloadType payloadType() const { return TIME_CODE; }
+  SEITimeCode() {}
+  virtual ~SEITimeCode(){}
+
+  UInt numClockTs;
+  TComSEITimeSet timeSetArray[MAX_TIMECODE_SEI_SETS];
+};
+
+
+class SEIMasteringDisplayColourVolume : public SEI
+{
+public:
+    PayloadType payloadType() const { return MASTERING_DISPLAY_COLOUR_VOLUME; }
+    SEIMasteringDisplayColourVolume() {}
+    virtual ~SEIMasteringDisplayColourVolume(){}
+
+    TComSEIMasteringDisplay values;
+};
+
+
+class SEISegmentedRectFramePacking : public SEI
+{
+public:
+  PayloadType payloadType() const { return SEGM_RECT_FRAME_PACKING; }
+
+  SEISegmentedRectFramePacking() {}
+  virtual ~SEISegmentedRectFramePacking() {}
+
+  Bool m_arrangementCancelFlag;
+  Int  m_contentInterpretationType;
+  Bool m_arrangementPersistenceFlag;
+};
+
+
+//definition according to P1005_v1;
+class SEITempMotionConstrainedTileSets: public SEI
+{
+  class TileSetData
+  {
+    protected:
+      std::vector<Int> m_top_left_tile_index;  //[tileSetIdx][tileIdx];
+      std::vector<Int> m_bottom_right_tile_index;
+
+    public:
+      Int     m_mcts_id;
+      Bool    m_display_tile_set_flag;
+      Int     m_num_tile_rects_in_set; //_minus1;
+      Bool    m_exact_sample_value_match_flag;
+      Bool    m_mcts_tier_level_idc_present_flag;
+      Bool    m_mcts_tier_flag;
+      Int     m_mcts_level_idc;
+
+      Void setNumberOfTileRects(const Int number)
+      {
+        m_top_left_tile_index    .resize(number);
+        m_bottom_right_tile_index.resize(number);
+      }
+
+      Int  getNumberOfTileRects() const
+      {
+        assert(m_top_left_tile_index.size() == m_bottom_right_tile_index.size());
+        return Int(m_top_left_tile_index.size());
+      }
+
+            Int &topLeftTileIndex    (const Int tileRectIndex)       { return m_top_left_tile_index    [tileRectIndex]; }
+            Int &bottomRightTileIndex(const Int tileRectIndex)       { return m_bottom_right_tile_index[tileRectIndex]; }
+      const Int &topLeftTileIndex    (const Int tileRectIndex) const { return m_top_left_tile_index    [tileRectIndex]; }
+      const Int &bottomRightTileIndex(const Int tileRectIndex) const { return m_bottom_right_tile_index[tileRectIndex]; }
+  };
+
+protected:
+  std::vector<TileSetData> m_tile_set_data;
+
+public:
+
+  Bool    m_mc_all_tiles_exact_sample_value_match_flag;
+  Bool    m_each_tile_one_tile_set_flag;
+  Bool    m_limited_tile_set_display_flag;
+  Bool    m_max_mcs_tier_level_idc_present_flag;
+  Bool    m_max_mcts_tier_flag;
+  Int     m_max_mcts_level_idc;
+
+  PayloadType payloadType() const { return TEMP_MOTION_CONSTRAINED_TILE_SETS; }
+  SEITempMotionConstrainedTileSets() { }
+  virtual ~SEITempMotionConstrainedTileSets() { }
+
+  Void setNumberOfTileSets(const Int number)       { m_tile_set_data.resize(number);     }
+  Int  getNumberOfTileSets()                 const { return Int(m_tile_set_data.size()); }
+
+        TileSetData &tileSetData (const Int index)       { return m_tile_set_data[index]; }
+  const TileSetData &tileSetData (const Int index) const { return m_tile_set_data[index]; }
+
+};
+
+
+class SEIChromaResamplingFilterHint : public SEI
+{
+public:
+  PayloadType payloadType() const {return CHROMA_RESAMPLING_FILTER_HINT;}
+  SEIChromaResamplingFilterHint() {}
+  virtual ~SEIChromaResamplingFilterHint() {}
+
+  Int                            m_verChromaFilterIdc;
+  Int                            m_horChromaFilterIdc;
+  Bool                           m_verFilteringFieldProcessingFlag;
+  Int                            m_targetFormatIdc;
+  Bool                           m_perfectReconstructionFlag;
+  std::vector<std::vector<Int> > m_verFilterCoeff;
+  std::vector<std::vector<Int> > m_horFilterCoeff;
+};
+
+
 class SEIKneeFunctionInfo : public SEI
 {
@@ -484,4 +801,5 @@
 };
 
+
 class SEIColourRemappingInfo : public SEI
 {
@@ -503,5 +821,5 @@
 
   Void copyFrom( const SEIColourRemappingInfo &seiCriInput)
-      {
+  {
     (*this) = seiCriInput;
   }
@@ -526,138 +844,53 @@
 };
 
-class SEIChromaResamplingFilterHint : public SEI
-{
-public:
-  PayloadType payloadType() const {return CHROMA_RESAMPLING_FILTER_HINT;}
-  SEIChromaResamplingFilterHint() {}
-  virtual ~SEIChromaResamplingFilterHint() {}
-
-  Int   m_verChromaFilterIdc;
-  Int   m_horChromaFilterIdc;
-  Bool                           m_verFilteringFieldProcessingFlag;
-  Int   m_targetFormatIdc;
-  Bool  m_perfectReconstructionFlag;
-  std::vector<std::vector<Int> > m_verFilterCoeff;
-  std::vector<std::vector<Int> > m_horFilterCoeff;
-};
-
-class SEIMasteringDisplayColourVolume : public SEI
-{
-public:
-    PayloadType payloadType() const { return MASTERING_DISPLAY_COLOUR_VOLUME; }
-    SEIMasteringDisplayColourVolume() {}
-    virtual ~SEIMasteringDisplayColourVolume(){}
-
-    TComSEIMasteringDisplay values;
-};
-
-typedef std::list<SEI*> SEIMessages;
-
-/// output a selection of SEI messages by payload type. Ownership stays in original message list.
-SEIMessages getSeisByType(SEIMessages &seiList, SEI::PayloadType seiType);
-
-/// remove a selection of SEI messages by payload type from the original list and return them in a new list.
-SEIMessages extractSeisByType(SEIMessages &seiList, SEI::PayloadType seiType);
-
-/// delete list of SEI messages (freeing the referenced objects)
-Void deleteSEIs (SEIMessages &seiList);
-
-class SEIScalableNesting : public SEI
-{
-public:
-  PayloadType payloadType() const { return SCALABLE_NESTING; }
-
-  SEIScalableNesting() {}
-
-  virtual ~SEIScalableNesting()
-  {
-    deleteSEIs(m_nestedSEIs);
-  }
-
-  Bool  m_bitStreamSubsetFlag;
-  Bool  m_nestingOpFlag;
-  Bool  m_defaultOpFlag;                             //value valid if m_nestingOpFlag != 0
-  UInt  m_nestingNumOpsMinus1;                       // -"-
-  UInt  m_nestingMaxTemporalIdPlus1[MAX_TLAYER];     // -"-
-  UInt  m_nestingOpIdx[MAX_NESTING_NUM_OPS];         // -"-
-
-  Bool  m_allLayersFlag;                             //value valid if m_nestingOpFlag == 0
-  UInt  m_nestingNoOpMaxTemporalIdPlus1;             //value valid if m_nestingOpFlag == 0 and m_allLayersFlag == 0
-  UInt  m_nestingNumLayersMinus1;                    //value valid if m_nestingOpFlag == 0 and m_allLayersFlag == 0
-  UChar m_nestingLayerId[MAX_NESTING_NUM_LAYER];     //value valid if m_nestingOpFlag == 0 and m_allLayersFlag == 0. This can e.g. be a static array of 64 UChar values
-
-  SEIMessages m_nestedSEIs;
-};
-
-class SEITimeCode : public SEI
-{
-public:
-  PayloadType payloadType() const { return TIME_CODE; }
-  SEITimeCode() {}
-  virtual ~SEITimeCode(){}
-
-  UInt numClockTs;
-  TComSEITimeSet timeSetArray[MAX_TIMECODE_SEI_SETS];
-};
-
-//definition according to P1005_v1;
-class SEITempMotionConstrainedTileSets: public SEI
-{
-  struct TileSetData
-  {
-    protected:
-      std::vector<Int> m_top_left_tile_index;  //[tileSetIdx][tileIdx];
-      std::vector<Int> m_bottom_right_tile_index;
-
-    public:
-      Int     m_mcts_id;
-      Bool    m_display_tile_set_flag;
-      Int     m_num_tile_rects_in_set; //_minus1;
-      Bool    m_exact_sample_value_match_flag;
-      Bool    m_mcts_tier_level_idc_present_flag;
-      Bool    m_mcts_tier_flag;
-      Int     m_mcts_level_idc;
-
-      Void setNumberOfTileRects(const Int number)
-      {
-        m_top_left_tile_index    .resize(number);
-        m_bottom_right_tile_index.resize(number);
-      }
-
-      Int  getNumberOfTileRects() const
-      {
-        assert(m_top_left_tile_index.size() == m_bottom_right_tile_index.size());
-        return Int(m_top_left_tile_index.size());
-      }
-
-            Int &topLeftTileIndex    (const Int tileRectIndex)       { return m_top_left_tile_index    [tileRectIndex]; }
-            Int &bottomRightTileIndex(const Int tileRectIndex)       { return m_bottom_right_tile_index[tileRectIndex]; }
-      const Int &topLeftTileIndex    (const Int tileRectIndex) const { return m_top_left_tile_index    [tileRectIndex]; }
-      const Int &bottomRightTileIndex(const Int tileRectIndex) const { return m_bottom_right_tile_index[tileRectIndex]; }
-  };
-
-protected:
-  std::vector<TileSetData> m_tile_set_data;
-
-public:
-
-  Bool    m_mc_all_tiles_exact_sample_value_match_flag;
-  Bool    m_each_tile_one_tile_set_flag;
-  Bool    m_limited_tile_set_display_flag;
-  Bool    m_max_mcs_tier_level_idc_present_flag;
-  Bool    m_max_mcts_tier_flag;
-  Int     m_max_mcts_level_idc;
-
-  PayloadType payloadType() const { return TEMP_MOTION_CONSTRAINED_TILE_SETS; }
-
-  Void setNumberOfTileSets(const Int number)       { m_tile_set_data.resize(number);     }
-  Int  getNumberOfTileSets()                 const { return Int(m_tile_set_data.size()); }
-
-        TileSetData &tileSetData (const Int index)       { return m_tile_set_data[index]; }
-  const TileSetData &tileSetData (const Int index) const { return m_tile_set_data[index]; }
-
-};
-
-#if U0033_ALTERNATIVE_TRANSFER_CHARACTERISTICS_SEI
+
+class SEIDeinterlaceFieldIdentification : public SEI
+{
+public:
+    PayloadType payloadType() const { return  DEINTERLACE_FIELD_IDENTIFICATION; }
+    SEIDeinterlaceFieldIdentification() { }
+
+    virtual ~SEIDeinterlaceFieldIdentification() {}
+
+    Bool m_deinterlacedPictureSourceParityFlag;
+};
+
+
+class SEIContentLightLevelInfo : public SEI
+{
+public:
+    PayloadType payloadType() const { return CONTENT_LIGHT_LEVEL_INFO; }
+    SEIContentLightLevelInfo() { }
+
+    virtual ~SEIContentLightLevelInfo() { }
+
+    UInt m_maxContentLightLevel;
+    UInt m_maxPicAverageLightLevel;
+};
+
+
+class SEIDependentRAPIndication : public SEI
+{
+public:
+  PayloadType payloadType() const { return DEPENDENT_RAP_INDICATION; }
+  SEIDependentRAPIndication() { }
+
+  virtual ~SEIDependentRAPIndication() { }
+};
+
+
+class SEICodedRegionCompletion : public SEI
+{
+public:
+  PayloadType payloadType() const { return CODED_REGION_COMPLETION; }
+  SEICodedRegionCompletion() { }
+
+  virtual ~SEICodedRegionCompletion() { }
+
+  UInt m_nextSegmentAddress;
+  Bool m_independentSliceSegmentFlag;
+};
+
+
 class SEIAlternativeTransferCharacteristics : public SEI
 {
@@ -672,5 +905,18 @@
   UInt m_preferredTransferCharacteristics;
 };
-#endif
+
+
+class SEIAmbientViewingEnvironment : public SEI
+{
+public:
+  PayloadType payloadType() const { return AMBIENT_VIEWING_ENVIRONMENT; }
+  SEIAmbientViewingEnvironment() { }
+
+  virtual ~SEIAmbientViewingEnvironment() { }
+
+  UInt m_ambientIlluminance;
+  UShort m_ambientLightX;
+  UShort m_ambientLightY;
+};
 
 
Index: /trunk/source/Lib/TLibCommon/TComBitCounter.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComBitCounter.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComBitCounter.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComBitStream.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComBitStream.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComBitStream.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComBitStream.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComBitStream.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComBitStream.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComCABACTables.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComCABACTables.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComCABACTables.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComCABACTables.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComCABACTables.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComCABACTables.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComChromaFormat.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComChromaFormat.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComChromaFormat.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComChromaFormat.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComChromaFormat.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComChromaFormat.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
